diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/mpdu-aggregator.cc ns-3.31/src/wifi/model/mpdu-aggregator.cc
--- ns-3.30.1/src/wifi/model/mpdu-aggregator.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/mpdu-aggregator.cc	2020-06-27 17:38:30.000000000 -0700
@@ -95,41 +95,12 @@
   AddWifiMacTrailer (tmp);
 
   // add A-MPDU subframe header and MPDU to the A-MPDU
-  AmpduSubframeHeader hdr;
-  hdr.SetLength (static_cast<uint16_t> (tmp->GetSize ()));
-  if (isSingle)
-    {
-      hdr.SetEof (1);
-    }
+  AmpduSubframeHeader hdr = GetAmpduSubframeHeader (static_cast<uint16_t> (tmp->GetSize ()), isSingle);
 
   tmp->AddHeader (hdr);
   ampdu->AddAtEnd (tmp);
 }
 
-void
-MpduAggregator::AddHeaderAndPad (Ptr<Packet> mpdu, bool last, bool isSingleMpdu)
-{
-  NS_LOG_FUNCTION (mpdu << last << isSingleMpdu);
-  AmpduSubframeHeader currentHdr;
-
-  //This is called to prepare packets from the aggregate queue to be sent so no need to check total size since it has already been
-  //done before when deciding how many packets to add to the queue
-  currentHdr.SetLength (static_cast<uint16_t> (mpdu->GetSize ()));
-  if (isSingleMpdu)
-    {
-      currentHdr.SetEof (1);
-    }
-
-  mpdu->AddHeader (currentHdr);
-  uint32_t padding = CalculatePadding (mpdu->GetSize ());
-
-  if (padding && !last)
-    {
-      Ptr<Packet> pad = Create<Packet> (padding);
-      mpdu->AddAtEnd (pad);
-    }
-}
-
 uint32_t
 MpduAggregator::GetSizeIfAggregated (uint32_t mpduSize, uint32_t ampduSize)
 {
@@ -222,96 +193,16 @@
   return (4 - (ampduSize % 4 )) % 4;
 }
 
-MpduAggregator::DeaggregatedMpdus
-MpduAggregator::Deaggregate (Ptr<Packet> aggregatedPacket)
-{
-  NS_LOG_FUNCTION_NOARGS ();
-  DeaggregatedMpdus set;
-
-  AmpduSubframeHeader hdr;
-  Ptr<Packet> extractedMpdu = Create<Packet> ();
-  uint32_t maxSize = aggregatedPacket->GetSize ();
-  uint16_t extractedLength;
-  uint32_t padding;
-  uint32_t deserialized = 0;
-
-  while (deserialized < maxSize)
-    {
-      deserialized += aggregatedPacket->RemoveHeader (hdr);
-      extractedLength = hdr.GetLength ();
-      extractedMpdu = aggregatedPacket->CreateFragment (0, static_cast<uint32_t> (extractedLength));
-      aggregatedPacket->RemoveAtStart (extractedLength);
-      deserialized += extractedLength;
-
-      padding = (4 - (extractedLength % 4 )) % 4;
-
-      if (padding > 0 && deserialized < maxSize)
-        {
-          aggregatedPacket->RemoveAtStart (padding);
-          deserialized += padding;
-        }
-
-      std::pair<Ptr<Packet>, AmpduSubframeHeader> packetHdr (extractedMpdu, hdr);
-      set.push_back (packetHdr);
-    }
-  NS_LOG_INFO ("Deaggreated A-MPDU: extracted " << set.size () << " MPDUs");
-  return set;
-}
-
-std::list<Ptr<const Packet>>
-MpduAggregator::PeekAmpduSubframes (Ptr<const Packet> aggregatedPacket)
+AmpduSubframeHeader
+MpduAggregator::GetAmpduSubframeHeader (uint16_t mpduSize, bool isSingle)
 {
-  NS_LOG_FUNCTION (aggregatedPacket);
-  std::list<Ptr<const Packet> > ampduSubframes;
-
   AmpduSubframeHeader hdr;
-  uint32_t maxSize = aggregatedPacket->GetSize ();
-  uint16_t bytesToExtract;
-  uint32_t padding;
-  uint32_t deserialized = 0;
-
-  Ptr<Packet> tempPacket = Create<Packet> ();
-  while (deserialized < maxSize)
-    {
-      tempPacket = aggregatedPacket->CreateFragment (deserialized, hdr.GetSerializedSize ());
-      bytesToExtract = tempPacket->PeekHeader (hdr);
-      bytesToExtract += hdr.GetLength ();
-
-      padding = (4 - (hdr.GetLength () % 4 )) % 4;
-      if (padding > 0 && (deserialized + bytesToExtract) < maxSize)
-        {
-          bytesToExtract += padding;
-        }
-
-      ampduSubframes.push_back (aggregatedPacket->CreateFragment (deserialized , bytesToExtract));
-      deserialized += bytesToExtract;
-    }
-  NS_LOG_INFO ("Peek A-MPDU subframes of A-MPDU: peeked " << ampduSubframes.size () << " A-MPDU subrames");
-  return ampduSubframes;
-}
-
-std::list<Ptr<const Packet>>
-MpduAggregator::PeekMpdus (Ptr<const Packet> aggregatedPacket)
-{
-  NS_LOG_FUNCTION (aggregatedPacket);
-  std::list<Ptr<const Packet> > ampduSubframes = PeekAmpduSubframes (aggregatedPacket);
-  std::list<Ptr<const Packet> > mpdus;
-
-  for (const auto& subframe : ampduSubframes)
+  hdr.SetLength (mpduSize);
+  if (isSingle)
     {
-      mpdus.push_back (PeekMpduInAmpduSubframe (subframe));
+      hdr.SetEof (1);
     }
-  NS_LOG_INFO ("Peek MPDUs of A-MPDU: peeked " << mpdus.size () << " MPDUs");
-  return mpdus;
-}
-
-Ptr<const Packet>
-MpduAggregator::PeekMpduInAmpduSubframe (Ptr<const Packet> ampduSubframe)
-{
-  NS_LOG_FUNCTION (ampduSubframe);
-  AmpduSubframeHeader hdr;
-  uint32_t headerSize = ampduSubframe->PeekHeader (hdr);
-  return ampduSubframe->CreateFragment (headerSize , hdr.GetLength ());
+  return hdr;
 }
 
 std::vector<Ptr<WifiMacQueueItem>>
@@ -337,10 +228,10 @@
       return mpduList;
     }
 
-  //Have to make sure that the block ACK agreement is established before sending an A-MPDU
+  //Have to make sure that the block ack agreement is established before sending an A-MPDU
   if (edcaIt->second->GetBaAgreementEstablished (recipient, tid))
     {
-      /* here is performed mpdu aggregation */
+      /* here is performed MPDU aggregation */
       uint16_t startingSequenceNumber = edcaIt->second->GetBaStartingSequence (recipient, tid);
       Ptr<WifiMacQueueItem> nextMpdu;
       uint16_t maxMpdus = edcaIt->second->GetBaBufferSize (recipient, tid);
@@ -349,7 +240,7 @@
       // check if the received MPDU meets the size and duration constraints
       if (edcaIt->second->GetLow ()->IsWithinSizeAndTimeLimits (mpdu, txVector, 0, ppduDurationLimit))
         {
-          // mpdu can be aggregated
+          // MPDU can be aggregated
           nextMpdu = Copy (mpdu);
         }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/mpdu-aggregator.h ns-3.31/src/wifi/model/mpdu-aggregator.h
--- ns-3.30.1/src/wifi/model/mpdu-aggregator.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/mpdu-aggregator.h	2020-06-27 17:38:30.000000000 -0700
@@ -42,14 +42,6 @@
 {
 public:
   /**
-   * A list of deaggregated packets and their A-MPDU subframe headers.
-   */
-  typedef std::list<std::pair<Ptr<Packet>, AmpduSubframeHeader> > DeaggregatedMpdus;
-  /**
-   * A constant iterator for a list of deaggregated packets and their A-MPDU subframe headers.
-   */
-  typedef std::list<std::pair<Ptr<Packet>, AmpduSubframeHeader> >::const_iterator DeaggregatedMpdusCI;
-  /**
    * EDCA queues typedef
    */
   typedef std::map<AcIndex, Ptr<QosTxop> > EdcaQueues;
@@ -74,21 +66,12 @@
   static void Aggregate (Ptr<const WifiMacQueueItem> mpdu, Ptr<Packet> ampdu, bool isSingle);
 
   /**
-   * \param mpdu the MPDU we want to insert into an A-MPDU subframe.
-   * \param last true if it is the last MPDU.
-   * \param isSingleMpdu true if it is a single MPDU
-   *
-   * Adds A-MPDU subframe header and padding to each MPDU that is part of an A-MPDU before it is sent.
-   */
-  static void AddHeaderAndPad (Ptr<Packet> mpdu, bool last, bool isSingleMpdu);
-
-  /**
    * Compute the size of the A-MPDU resulting from the aggregation of an MPDU of
    * size <i>mpduSize</i> and an A-MPDU of size <i>ampduSize</i>.
    *
-   * \param mpduSize the MPDU size.
-   * \param ampduSize the A-MPDU size.
-   * \return the size of the resulting A-MPDU.
+   * \param mpduSize the MPDU size in bytes.
+   * \param ampduSize the A-MPDU size in bytes.
+   * \return the size of the resulting A-MPDU in bytes.
    */
   static uint32_t GetSizeIfAggregated (uint32_t mpduSize, uint32_t ampduSize);
 
@@ -99,7 +82,7 @@
    * \param recipient the receiver station address.
    * \param tid the TID.
    * \param modulation the modulation class.
-   * \return the maximum A-MPDU size.
+   * \return the maximum A-MPDU size in bytes.
    */
   uint32_t GetMaxAmpduSize (Mac48Address recipient, uint8_t tid,
                             WifiModulationClass modulation) const;
@@ -113,7 +96,8 @@
    *
    * - the time to transmit the resulting PPDU, according to the given TxVector,
    * does not exceed both the maximum PPDU duration allowed by the corresponding
-   * modulation class (if any) and the given PPDU duration limit (if non null)
+   * modulation class (if any) and the given PPDU duration limit (if distinct from
+   * Time::Min ())
    *
    * For now, only non-broadcast QoS Data frames can be aggregated (do not pass
    * other types of frames to this method). MPDUs to aggregate are looked for
@@ -133,39 +117,7 @@
    */
   std::vector<Ptr<WifiMacQueueItem>> GetNextAmpdu (Ptr<const WifiMacQueueItem> mpdu,
                                                    WifiTxVector txVector,
-                                                   Time ppduDurationLimit = Seconds (0)) const;
-
-  /**
-   * Deaggregates an A-MPDU by removing the A-MPDU subframe header and padding.
-   *
-   * \param aggregatedPacket the aggregated packet
-   * \return list of deaggragted packets and their A-MPDU subframe headers
-   */
-  static DeaggregatedMpdus Deaggregate (Ptr<Packet> aggregatedPacket);
-
-  /**
-   * Peeks the A-MPDU subframes of the provided A-MPDU.
-   *
-   * \param aggregatedPacket the aggregated packet
-   * \return list of A-MPDU subframes (i.e. A-MPDU subframe header + MPDU + eventual padding)
-   */
-  static std::list<Ptr<const Packet>> PeekAmpduSubframes (Ptr<const Packet> aggregatedPacket);
-
-  /**
-   * Peeks the MPDUs of the provided A-MPDU.
-   *
-   * \param aggregatedPacket the aggregated packet
-   * \return list of MPDUs
-   */
-  static std::list<Ptr<const Packet>> PeekMpdus (Ptr<const Packet> aggregatedPacket);
-
-  /**
-   * Peeks the MPDU contained in the A-MPDU subframe.
-   *
-   * \param ampduSubframe the A-MPDU subframe
-   * \return the MPDU contained in the A-MPDU subframe
-   */
-  static Ptr<const Packet> PeekMpduInAmpduSubframe (Ptr<const Packet> ampduSubframe);
+                                                   Time ppduDurationLimit = Time::Min ()) const;
 
   /**
    * Set the map of EDCA queues.
@@ -174,10 +126,9 @@
    */
   void SetEdcaQueues (EdcaQueues edcaQueues);
 
-private:
   /**
-   * \param ampduSize the size of the A-MPDU that needs to be padded
-   * \return the size of the padding that must be added to the end of an A-MPDU
+   * \param ampduSize the size of the A-MPDU that needs to be padded in bytes
+   * \return the size of the padding that must be added to the end of an A-MPDU in bytes
    *
    * Calculates how much padding must be added to the end of an A-MPDU of the given size
    * (once another MPDU is aggregated).
@@ -185,6 +136,16 @@
    */
   static uint8_t CalculatePadding (uint32_t ampduSize);
 
+  /**
+   * Get the A-MPDU subframe header corresponding to the MPDU size and
+   * whether the MPDU is a single MPDU.
+   *
+   * \param mpduSize size of the MPDU in bytes.
+   * \param isSingle true if S-MPDU.
+   */
+  static AmpduSubframeHeader GetAmpduSubframeHeader (uint16_t mpduSize, bool isSingle);
+
+private:
   EdcaQueues m_edca;   //!< the map of EDCA queues
 };
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/msdu-aggregator.cc ns-3.31/src/wifi/model/msdu-aggregator.cc
--- ns-3.30.1/src/wifi/model/msdu-aggregator.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/msdu-aggregator.cc	2020-06-27 17:38:30.000000000 -0700
@@ -75,36 +75,6 @@
   return amsduSize + CalculatePadding (amsduSize) + 14 + msduSize;
 }
 
-void
-MsduAggregator::Aggregate (Ptr<const Packet> msdu, Ptr<Packet> amsdu,
-                           Mac48Address src, Mac48Address dest) const
-{
-  NS_LOG_FUNCTION (this);
-  NS_ASSERT (amsdu);
-
-  // pad the previous A-MSDU subframe if the A-MSDU is not empty
-  if (amsdu->GetSize () > 0)
-    {
-      uint8_t padding = CalculatePadding (amsdu->GetSize ());
-
-      if (padding)
-        {
-          Ptr<Packet> pad = Create<Packet> (padding);
-          amsdu->AddAtEnd (pad);
-        }
-    }
-
-  // add A-MSDU subframe header and MSDU
-  AmsduSubframeHeader hdr;
-  hdr.SetDestinationAddr (dest);
-  hdr.SetSourceAddr (src);
-  hdr.SetLength (static_cast<uint16_t> (msdu->GetSize ()));
-
-  Ptr<Packet> tmp = msdu->Copy ();
-  tmp->AddHeader (hdr);
-  amsdu->AddAtEnd (tmp);
-}
-
 Ptr<WifiMacQueueItem>
 MsduAggregator::GetNextAmsdu (Mac48Address recipient, uint8_t tid,
                               WifiTxVector txVector, uint32_t ampduSize,
@@ -145,10 +115,8 @@
       return 0;
     }
 
-  Ptr<Packet> amsdu = Create<Packet> ();
+  Ptr<WifiMacQueueItem> amsdu = Create<WifiMacQueueItem> (Create<const Packet> (), (*peekedIt)->GetHeader ());
   uint8_t nMsdu = 0;
-  WifiMacHeader header = (*peekedIt)->GetHeader ();
-  Time tstamp = (*peekedIt)->GetTimeStamp ();
   // We need to keep track of the first MSDU. When it is processed, it is not known
   // if aggregation will succeed or not.
   WifiMacQueue::ConstIterator first = peekedIt;
@@ -160,7 +128,7 @@
     {
       // check if aggregating the peeked MSDU violates the A-MSDU size limit
       uint16_t newAmsduSize = GetSizeIfAggregated ((*peekedIt)->GetPacket ()->GetSize (),
-                                                   amsdu->GetSize ());
+                                                   amsdu->GetPacket ()->GetSize ());
 
       if (newAmsduSize > maxAmsduSize)
         {
@@ -170,33 +138,25 @@
 
       // check if the A-MSDU obtained by aggregating the peeked MSDU violates
       // the A-MPDU size limit or the PPDU duration limit
-      if (!qosTxop->GetLow ()->IsWithinSizeAndTimeLimits (header.GetSize () + newAmsduSize + WIFI_MAC_FCS_LENGTH,
+      if (!qosTxop->GetLow ()->IsWithinSizeAndTimeLimits (amsdu->GetHeader ().GetSize () + newAmsduSize
+                                                          + WIFI_MAC_FCS_LENGTH,
                                                           recipient, tid, txVector, ampduSize, ppduDurationLimit))
         {
           NS_LOG_DEBUG ("No other MSDU can be aggregated");
           break;
         }
 
-      // We can now safely aggregate the MSDU to the A-MSDU
-      Aggregate ((*peekedIt)->GetPacket (), amsdu,
-                 qosTxop->MapSrcAddressForAggregation (header),
-                 qosTxop->MapDestAddressForAggregation (header));
-
-      /* "The expiration of the A-MSDU lifetime timer occurs only when the lifetime
-       * timer of all of the constituent MSDUs of the A-MSDU have expired" (Section
-       * 10.12 of 802.11-2016)
-       */
-      // The timestamp of the A-MSDU is the most recent among those of the MSDUs
-      tstamp = Max (tstamp, (*peekedIt)->GetTimeStamp ());
-
+      // The MSDU can be aggregated to the A-MSDU.
       // If it is the first MSDU, move to the next one
       if (nMsdu == 0)
         {
+          amsdu = Copy (*peekedIt);
           peekedIt++;
         }
       // otherwise, remove it from the queue
       else
         {
+          amsdu->Aggregate (*peekedIt);
           peekedIt = queue->Remove (peekedIt);
         }
 
@@ -214,10 +174,7 @@
   // Aggregation succeeded, we have to remove the first MSDU
   queue->Remove (first);
 
-  header.SetQosAmsdu ();
-  header.SetAddr3 (qosTxop->GetLow ()->GetBssid ());
-
-  return Create<WifiMacQueueItem> (amsdu, header, tstamp);
+  return amsdu;
 }
 
 uint8_t
@@ -286,7 +243,7 @@
 
   // Determine the constraint imposed by the recipient based on the PPDU
   // format used to transmit the A-MSDU
-  if (modulation == WIFI_MOD_CLASS_HE || modulation == WIFI_MOD_CLASS_VHT)
+  if (modulation >= WIFI_MOD_CLASS_VHT)
     {
       // the maximum A-MSDU size is indirectly constrained by the maximum MPDU
       // size supported by the recipient and advertised in the VHT Capabilities
@@ -343,7 +300,7 @@
           deserialized += padding;
         }
 
-      std::pair<Ptr<Packet>, AmsduSubframeHeader> packetHdr (extractedMsdu, hdr);
+      std::pair<Ptr<const Packet>, AmsduSubframeHeader> packetHdr (extractedMsdu, hdr);
       set.push_back (packetHdr);
     }
   NS_LOG_INFO ("Deaggreated A-MSDU: extracted " << set.size () << " MSDUs");
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/msdu-aggregator.h ns-3.31/src/wifi/model/msdu-aggregator.h
--- ns-3.30.1/src/wifi/model/msdu-aggregator.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/msdu-aggregator.h	2020-06-27 17:38:30.000000000 -0700
@@ -25,6 +25,7 @@
 #include "ns3/nstime.h"
 #include "wifi-mode.h"
 #include "qos-utils.h"
+#include <map>
 
 namespace ns3 {
 
@@ -42,9 +43,9 @@
 {
 public:
   /// DeaggregatedMsdus typedef
-  typedef std::list<std::pair<Ptr<Packet>, AmsduSubframeHeader> > DeaggregatedMsdus;
+  typedef std::list<std::pair<Ptr<const Packet>, AmsduSubframeHeader> > DeaggregatedMsdus;
   /// DeaggregatedMsdusCI typedef
-  typedef std::list<std::pair<Ptr<Packet>, AmsduSubframeHeader> >::const_iterator DeaggregatedMsdusCI;
+  typedef std::list<std::pair<Ptr<const Packet>, AmsduSubframeHeader> >::const_iterator DeaggregatedMsdusCI;
   /// EDCA queues typedef
   typedef std::map<AcIndex, Ptr<QosTxop> > EdcaQueues;
 
@@ -58,25 +59,14 @@
   virtual ~MsduAggregator ();
 
   /**
-   * Aggregate an MSDU to an A-MSDU.
-   *
-   * \param msdu the MSDU.
-   * \param amsdu the A-MSDU.
-   * \param src the source address.
-   * \param dest the destination address
-   */
-  void Aggregate (Ptr<const Packet> msdu, Ptr<Packet> amsdu,
-                  Mac48Address src, Mac48Address dest) const;
-
-  /**
    * Compute the size of the A-MSDU resulting from the aggregation of an MSDU of
    * size <i>msduSize</i> and an A-MSDU of size <i>amsduSize</i>.
    * Note that only the basic A-MSDU subframe format (section 9.3.2.2.2 of IEEE
    * 802.11-2016) is supported.
    *
-   * \param msduSize the MSDU size.
-   * \param amsduSize the A-MSDU size.
-   * \return the size of the resulting A-MSDU.
+   * \param msduSize the MSDU size in bytes.
+   * \param amsduSize the A-MSDU size in bytes.
+   * \return the size of the resulting A-MSDU in bytes.
    */
   static uint16_t GetSizeIfAggregated (uint16_t msduSize, uint16_t amsduSize);
 
@@ -95,7 +85,8 @@
    *
    * - the time to transmit the resulting PPDU, according to the given TxVector,
    * does not exceed both the maximum PPDU duration allowed by the corresponding
-   * modulation class (if any) and the given PPDU duration limit (if non null)
+   * modulation class (if any) and the given PPDU duration limit (if distinct from
+   * Time::Min ())
    *
    * If it is not possible to aggregate at least two MSDUs, no MSDU is dequeued
    * from the EDCA queue and a null pointer is returned.
@@ -103,13 +94,13 @@
    * \param recipient the receiver station address.
    * \param tid the TID.
    * \param txVector the TxVector used to transmit the frame
-   * \param ampduSize the size of the existing A-MPDU
+   * \param ampduSize the size of the existing A-MPDU in bytes
    * \param ppduDurationLimit the limit on the PPDU duration
    * \return the resulting A-MSDU, if aggregation is possible, 0 otherwise.
    */
   Ptr<WifiMacQueueItem> GetNextAmsdu (Mac48Address recipient, uint8_t tid,
                                       WifiTxVector txVector, uint32_t ampduSize = 0,
-                                      Time ppduDurationLimit = Seconds (0)) const;
+                                      Time ppduDurationLimit = Time::Min ()) const;
 
   /**
    * Determine the maximum size for an A-MSDU of the given TID that can be sent
@@ -118,7 +109,7 @@
    * \param recipient the receiver station address.
    * \param tid the TID.
    * \param modulation the modulation class.
-   * \return the maximum A-MSDU size.
+   * \return the maximum A-MSDU size in bytes.
    */
   uint16_t GetMaxAmsduSize (Mac48Address recipient, uint8_t tid,
                             WifiModulationClass modulation) const;
@@ -137,7 +128,6 @@
    */
   void SetEdcaQueues (EdcaQueues map);
 
-private:
   /**
    * Calculate how much padding must be added to the end of an A-MSDU of the
    * given size if a new MSDU is added.
@@ -149,6 +139,7 @@
    */
   static uint8_t CalculatePadding (uint16_t amsduSize);
 
+private:
   EdcaQueues m_edca;   //!< the map of EDCA queues
 };
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/nist-error-rate-model.h ns-3.31/src/wifi/model/nist-error-rate-model.h
--- ns-3.30.1/src/wifi/model/nist-error-rate-model.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/nist-error-rate-model.h	2020-06-27 17:38:30.000000000 -0700
@@ -51,16 +51,16 @@
   /**
    * Return the coded BER for the given p and b.
    *
-   * \param p
-   * \param bValue
+   * \param p the SNR ratio (not dB)
+   * \param bValue such that coding rate = bValue / (bValue + 1)
    *
-   * \return BER
+   * \return the coded BER
    */
   double CalculatePe (double p, uint32_t bValue) const;
   /**
    * Return BER of BPSK at the given SNR.
    *
-   * \param snr snr ratio (not dB)
+   * \param snr SNR ratio (not dB)
    *
    * \return BER of BPSK at the given SNR
    */
@@ -68,7 +68,7 @@
   /**
    * Return BER of QPSK at the given SNR.
    *
-   * \param snr snr ratio (not dB)
+   * \param snr SNR ratio (not dB)
    *
    * \return BER of QPSK at the given SNR
    */
@@ -76,7 +76,7 @@
   /**
    * Return BER of QAM16 at the given SNR.
    *
-   * \param snr snr ratio (not dB)
+   * \param snr SNR ratio (not dB)
    *
    * \return BER of QAM16 at the given SNR
    */
@@ -84,7 +84,7 @@
   /**
    * Return BER of QAM64 at the given SNR.
    *
-   * \param snr snr ratio (not dB)
+   * \param snr SNR ratio (not dB)
    *
    * \return BER of QAM64 at the given SNR
    */
@@ -92,23 +92,23 @@
   /**
    * Return BER of QAM256 at the given SNR.
    *
-   * \param snr snr ratio (not dB)
+   * \param snr SNR ratio (not dB)
    * \return BER of QAM256 at the given SNR
    */
   double Get256QamBer (double snr) const;
   /**
    * Return BER of QAM1024 at the given SNR.
    *
-   * \param snr snr ratio (not dB)
+   * \param snr SNR ratio (not dB)
    * \return BER of QAM1024 at the given SNR
    */
   double Get1024QamBer (double snr) const;
   /**
    * Return BER of BPSK at the given SNR after applying FEC.
    *
-   * \param snr snr ratio (not dB)
+   * \param snr SNR ratio (not dB)
    * \param nbits the number of bits in the chunk
-   * \param bValue
+   * \param bValue such that coding rate = bValue / (bValue + 1)
    *
    * \return BER of BPSK at the given SNR after applying FEC
    */
@@ -117,9 +117,9 @@
   /**
    * Return BER of QPSK at the given SNR after applying FEC.
    *
-   * \param snr snr ratio (not dB)
+   * \param snr SNR ratio (not dB)
    * \param nbits the number of bits in the chunk
-   * \param bValue
+   * \param bValue such that coding rate = bValue / (bValue + 1)
    *
    * \return BER of QPSK at the given SNR after applying FEC
    */
@@ -128,9 +128,9 @@
   /**
    * Return BER of QAM16 at the given SNR after applying FEC.
    *
-   * \param snr snr ratio (not dB)
+   * \param snr SNR ratio (not dB)
    * \param nbits the number of bits in the chunk
-   * \param bValue
+   * \param bValue such that coding rate = bValue / (bValue + 1)
    *
    * \return BER of QAM16 at the given SNR after applying FEC
    */
@@ -139,9 +139,9 @@
   /**
    * Return BER of QAM64 at the given SNR after applying FEC.
    *
-   * \param snr snr ratio (not dB)
+   * \param snr SNR ratio (not dB)
    * \param nbits the number of bits in the chunk
-   * \param bValue
+   * \param bValue such that coding rate = bValue / (bValue + 1)
    *
    * \return BER of QAM64 at the given SNR after applying FEC
    */
@@ -150,9 +150,9 @@
   /**
    * Return BER of QAM256 at the given SNR after applying FEC.
    *
-   * \param snr snr ratio (not dB)
+   * \param snr SNR ratio (not dB)
    * \param nbits the number of bits in the chunk
-   * \param bValue
+   * \param bValue such that coding rate = bValue / (bValue + 1)
    * \return BER of QAM256 at the given SNR after applying FEC
    */
   double GetFec256QamBer (double snr, uint64_t nbits,
@@ -160,9 +160,9 @@
   /**
    * Return BER of QAM1024 at the given SNR after applying FEC.
    *
-   * \param snr snr ratio (not dB)
+   * \param snr SNR ratio (not dB)
    * \param nbits the number of bits in the chunk
-   * \param bValue
+   * \param bValue such that coding rate = bValue / (bValue + 1)
    * \return BER of QAM1024 at the given SNR after applying FEC
    */
   double GetFec1024QamBer (double snr, uint64_t nbits,
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/obss-pd-algorithm.cc ns-3.31/src/wifi/model/obss-pd-algorithm.cc
--- ns-3.30.1/src/wifi/model/obss-pd-algorithm.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/obss-pd-algorithm.cc	2020-06-27 17:38:30.000000000 -0700
@@ -38,7 +38,7 @@
     .SetParent<Object> ()
     .SetGroupName ("Wifi")
     .AddAttribute ("ObssPdLevel",
-                   "The current OBSS PD level.",
+                   "The current OBSS PD level (dBm).",
                    DoubleValue (-82.0),
                    MakeDoubleAccessor (&ObssPdAlgorithm::m_obssPdLevel),
                    MakeDoubleChecker<double> (-101, -62))
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/obss-pd-algorithm.h ns-3.31/src/wifi/model/obss-pd-algorithm.h
--- ns-3.30.1/src/wifi/model/obss-pd-algorithm.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/obss-pd-algorithm.h	2020-06-27 17:38:30.000000000 -0700
@@ -33,7 +33,7 @@
 
 /**
  * \brief OBSS PD algorithm interface
- * \ingroup wifi-he
+ * \ingroup wifi
  *
  * This object provides the interface for all OBSS_PD algorithms
  * and is designed to be subclassed.
@@ -45,6 +45,10 @@
 class ObssPdAlgorithm : public Object
 {
 public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
   static TypeId GetTypeId (void);
 
   /**
@@ -82,15 +86,18 @@
   virtual void DoDispose (void);
 
   Ptr<WifiNetDevice> m_device; ///< Pointer to the WifiNetDevice
-  double m_obssPdLevel;        ///< Current OBSS PD level
+  double m_obssPdLevel;        ///< Current OBSS PD level (dBm)
 
 
 private:
-  double m_obssPdLevelMin; ///< Minimum OBSS PD level
-  double m_obssPdLevelMax; ///< Maximum OBSS PD level
-  double m_txPowerRefSiso; ///< SISO reference TX power level
-  double m_txPowerRefMimo; ///< MIMO reference TX power level
+  double m_obssPdLevelMin; ///< Minimum OBSS PD level (dBm)
+  double m_obssPdLevelMax; ///< Maximum OBSS PD level (dBm)
+  double m_txPowerRefSiso; ///< SISO reference TX power level (dBm)
+  double m_txPowerRefMimo; ///< MIMO reference TX power level (dBm)
 
+  /**
+   * TracedCallback signature for PHY reset events.
+   */
   TracedCallback<uint8_t, double, bool, double, double>  m_resetEvent;
 };
 
